//!
//! Configuration to initialize the Fenrir networking library

use ::std::{net::SocketAddr, num::NonZeroUsize, option::Option, vec::Vec};

/// Main config for libFenrir
#[derive(Clone, Debug)]
pub struct Config {
    /// number of threads that libFenrir will use
    pub threads: Option<NonZeroUsize>,
    /// List of ipv4 or ipv6 UDP inet socket to listen on
    /// If empty, libFenrir will listen on a random UDP port on `0.0.0.0`
    pub listen: Vec<SocketAddr>,
}

impl Default for Config {
    fn default() -> Self {
        Config {
            threads: None,
            listen: Vec::new(),
        }
    }
}
